/*
 *  outerParticle.h
 *  particlesLines_VF
 *
 *  Created by Lien Tran on 10/17/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef OUTERPARTICLE_H
#define OUTERPARTICLE_H

#include "ofMain.h"
#include "ofxVectorMath.h"

class outerParticle
	{
    public:
        ofxVec2f pos;
        ofxVec2f vel;
        ofxVec2f frc;   // frc is also know as acceleration (newton says "f=ma")
        outerParticle();
		virtual ~outerParticle(){};
		
        void resetForce();
        void addForce(float x, float y);
        void addDampingForce();
        void setInitialCondition(float px, float py, float vx, float vy);
        void update();
        void draw();
		void bounceOffWalls();
		void addRepulsionForce( float px, float py, float radius, float strength);
		void addAttractionForce( float px, float py, float radius, float strength);
		void addClockwiseForce( float px, float py, float radius, float strength);
		void addCounterClockwiseForce( float px, float py, float radius, float strength);
		
		
		float damping;
//		ofPoint pts[10];
    protected:
    private:
	};

#endif // PARTICLE_H


