#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	//ofBackground(60, 60, 60);
	ofBackground(255, 255, 255);
		
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	VF.randomizeField(2.0);
	
	drawingStyle = 0;
	bFade = false;
	particleCounter = 0;
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	/*float xMap = ofMap(sin(ofGetElapsedTimef()), -1, 1, ofGetWidth()/4, 3*ofGetWidth()/4);
	float yMap = ofMap(sin(ofGetElapsedTimef()), -1, 1, ofGetHeight()/4, 3*ofGetHeight()/4);
																										 
	float xorig = 10*xMap;
	float yorig = 10*yMap;
	float radius = 10;
	float angle = ofGetElapsedTimef()*5;
	
	rotationPt.x = xorig + radius * cos(angle);
	rotationPt.y= yorig + radius * -sin(angle);*/

	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].resetForce();
		//particles[i].addAttractionForce(rotationPt.x, rotationPt.y, 1000, 0.1);
		//particles[i].addRepulsionForce(rotationPt.x, rotationPt.y, 50, 0.2);
		particles[i].addAttractionForce(mouseX, mouseY, 1000, 0.1);
		particles[i].addRepulsionForce(mouseX, mouseY, 50, 0.2);
		
		
		// if particles are near each other, apply repulsion force
		for (int j=0; j < i; j++){
			float particlesDistance = ofDist(particles[i].pos.x, particles[i].pos.y, particles[j].pos.x, particles[j].pos.y);
			if (particlesDistance > 10){
				particles[i].addRepulsionForce(particles[j].pos.x, particles[j].pos.y, 50, 1);
			} // end if
		} // end j-loop
		
		particles[i].addCounterClockwiseForce(mouseX, mouseY, 1000, 0.1);
		particles[i].addClockwiseForce(mouseX, mouseY, 200, 1);
		
		//particles[i].addForce(0,0.04);  // gravity
		particles[i].addDampingForce();
		particles[i].update();
		particles[i].bounceOffWalls();


	ofxVec2f frc;
	frc = VF.getForceFromPos(particles[i].pos.x, particles[i].pos.y);
	particles[i].addForce(frc.x, frc.y);
	particles[i].addDampingForce();
	particles[i].update();

		for (int f = 0; f < 10; f++) {
			ofxVec2f frc;
			frc = VF.getForceFromPos(particles[i].pts[f].pos.x, particles[i].pts[f].pos.y);
			particles[i].pts[f].addForce((frc.x*.0005), (frc.y*.0005));
			//pts[f].addDampingForce();
			particles[i].pts[f].bounceOffWalls();
			particles[i].pts[f].update();
			cout << frc.x << endl;
			
		} // end f-loop
		
		
	} // end i-loop
	
}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofEnableAlphaBlending();
	ofSetColor(0,130,130, 200);
//	VF.draw();
	
	ofSetColor(0x000000);
	
	// small particles that migrate
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();

		ofBeginShape();
//		ofVertex(particles[i].pos.x, particles[i].pos.y);

		// small particles connect to larger stationary points
		for (int j = 0; j < 10; j++) {
		//	for  (int j = 0; j < pts.size(); j++){
	
			// draw stationary points
			ofNoFill();
			ofSetColor(0xffffff);			
		//	ofCircle(pts[i].pos.x, pts[i].pos.y, 1);
			
			// repulse the small particles away from stationary points
			particles[i].addRepulsionForce(particles[i].pts[j].pos.x, particles[i].pts[j].pos.y, 5, .5);
			particles[i].pts[j].addAttractionForce(particles[i].pos.x, particles[i].pos.y, 10, 1);
			// connect the stationary points with a line to moving particles
			int lineLength = ofDist(particles[i].pos.x, particles[i].pos.y, particles[i].pts[j].pos.x, particles[i].pts[j].pos.y);
			//int alphaVal = ofMap(lineLength, 10, ofGetHeight()*1.4, 0, 255);
			ofFill();
			int colorVal = ofMap(lineLength, 10, ofGetHeight()*1.4, 0, 255);

			ofSetColor(colorVal, colorVal, colorVal,255-colorVal);
			ofVertex(particles[i].pts[j].pos.x, particles[i].pts[j].pos.y);
			//(particles[i].pos.x, particles[i].pos.y, pts[j].pos.x, pts[j].pos.y);
		} // end j
		ofEndShape();
		
	} // end i

/*	ofSetColor(0,130,130, 200);
	ofRect(30,30,300,75);
	ofSetColor(255,255,255, 230);
	ofDrawBitmapString("space to clear\nchange drawing mode 'a'\ntoggle fade 'f'", 50, 50);
	
	
	ofSetColor(255,255,130, 230);
	switch (drawingStyle){
		case 0: ofDrawBitmapString("drawing mode: inward", 50, 90);
			break;
		case 1: ofDrawBitmapString("drawing mode: outward", 50, 90);
			break;
		case 2: ofDrawBitmapString("drawing mode: clockwise", 50, 90);
			break;
		case 3: ofDrawBitmapString("drawing mode: counter-clockwise", 50, 90); 
			break;
	}	
*/	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	if (key == ' '){
		VF.clear();
	} else if (key == 'a'){
		drawingStyle ++;
		drawingStyle %= 4;
	} else if (key == 'f'){
		bFade = !bFade;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if (button == 0) {
		switch (drawingStyle){
			case 0: VF.addInwardCircle((float)x, (float)y, 200, 0.3f);
				break;
			case 1: VF.addOutwardCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 2: VF.addClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 3: VF.addCounterClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
		}		
	} 
	
	else {
		/*
		particles.erase(particles.begin());
		particle myParticle;
		myParticle.setInitialCondition(x,y,0,0, particleCounter);
		particles.push_back(myParticle);
		*/
		
	}
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	if (particles.size() > 20) {
		particles.erase(particles.begin());	
		return;
	}
	
	//	for (int i = 0; i < 10; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,1000),ofRandom(0,1000),0,0);
		// more interesting with diversity :)
		// uncomment this: 
		//myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
//	}
	
	//particle temp;
	//temp.pos.x = x;
	//temp.pos.y = y;
	//pts.push_back(temp);
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	particleCounter++;

}
